<template>
  <div class="orders">

    <h1 class="orders__title">Заказы</h1>

    <order-row v-for="order in limitedOrders"
               :key="order.id"
               class="orders__item"
               :order="order"
               :selectOptions="selectOptions"
               @orderCanceled="onCancelOrder"
               @needToUpdateOrders="updateOrders"
    >
    </order-row>

    <button v-if="(currentPage * ordersPerPage) < orders.length"
            type="button"
            class="button button--gray orders__show-more"
            @click="showMoreOrders">
      <icon-plus />
      Показать еще
    </button>

    <nuxt-child/>

  </div>
</template>

<script>
  import { mapGetters } from 'vuex';

  import IconPlus from '../../components/icons/IconPlus';
  import OrderRow from '../../components/OrderRow';

  import {
    getSeoBySlug,
    getOrders,
    updateOrderPayment
  } from '../../service/deliroom-service';


  export default {
    name: 'Orders',
    middleware: 'auth',
    components: {
      OrderRow,
      IconPlus
    },
    data: () => ({
      orders: [],

      currentPage: 1,
      ordersPerPage: 6,
    }),

    asyncData: async () => ({
      meta: await getSeoBySlug('/personal/orders'),
    }),

    async mounted() {
      const timer = setInterval(async () => {
        if (!this.$store.state.auth.tokenRefreshing) {
          clearInterval(timer);

          if (this.$route.path.includes('payment-success')
            || this.$route.path.includes('payment-failure')) {

            if (!this.$route.query.orderId) {
              this.$router.push('/personal/orders');
              return;
            }

            let updateResult = await updateOrderPayment(this.$route.query.orderId);

            if (this.$route.path.includes('payment-success')) {
              if (updateResult.error) {
                this.$notify({
                  group: 'errors',
                  type: 'error',
                  text: 'Оплата заказа не удалась.',
                });
              } else {
                this.$notify({
                  group: 'success',
                  type: 'success',
                  text: 'Заказ успешно оплачен.',
                });
              }
            } else {
              this.$notify({
                group: 'errors',
                type: 'error',
                text: 'Оплата заказа не удалась.',
              });
            }

            this.$router.push('/personal/orders');
          }

          await this.updateOrders();
        }
      }, 100);
    },

    computed: {
      ...mapGetters({
        balance: 'user/balance'
      }),

      limitedOrders() {
        return this.orders.filter((item, index) =>
          index < (this.ordersPerPage * this.currentPage))
      },

      selectOptions() {
        const result = [{ value: 'card', label: 'Банковской картой' }];

        if (this.balance) {
          result.push({ value: 'inner', label: `Внутренний счет ${this.balance} ₽` })
        }

        return result;
      },
    },

    methods: {
      showMoreOrders() {
        this.ordersPerPage += 6;
      },

      getBalance(events) {
        if (events.length <= 0) return 0;

        return `${Math.abs(events[events.length - 1].value)}`
      },

      onCancelOrder(event) {
        const { cancelResult, id } = event;

        this.orders = this.orders.map((order) => {
          if (order.id === id) {
            return { ...order, ...cancelResult.data };
          }

          return order;
        })
      },

      async updateOrders() {
        const ordersResult = await getOrders();
        this.orders = ordersResult.data;

        this.orders.sort((a, b) => {
          const aDate = Number(new Date(a.created_at));
          const bDate = Number(new Date(b.created_at));

          if (aDate < bDate) {
            return 1;
          }

          if (aDate > bDate) {
            return -1;
          }

          return 0;
        });

        this.orders.forEach(order => {
          order.comments.sort((a, b) => {
            const aDate = Number(new Date(a.created_at));
            const bDate = Number(new Date(b.created_at));

            if (aDate > bDate) {
              return 1;
            }

            if (aDate < bDate) {
              return -1;
            }

            return 0;
          })
        })
      }
    },

    head() {
      if (!this.meta) return;

      return {
        title: this.meta.title,
        meta: this.meta.meta.map((metaItem) => ({
          ...metaItem,
          hid: metaItem.name.toLowerCase(),
          name: metaItem.name.toLowerCase(),
        })),
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .orders {
    &__item {
      & + & {
        margin-top: rem(48);
      }
    }

    &__title {
      @include h2;

      margin-bottom: rem(50);

      @media (max-width: $mobile-width) {
        margin-bottom: rem(30);
      }
    }

    &__show-more {
      height: rem(60);
      margin-top: rem(40);
      padding: 0 rem(36) 0 rem(28);

      svg {
        width: rem(12);
        height: rem(12);

        margin-right: rem(10);
      }

      @media (max-width: $mobile-width) {
        margin-top: rem(40);
      }
    }
  }
</style>
